# frozen_string_literal: true

require 'json'
require_relative 'cards_manager'
require_relative 'query'
require_relative 'cards'

class QueryMtg
  def self.call(argv)
    new(argv).call
  end

  def call
    puts requested_cards
  rescue Query::RepeatedFilter, CardsManager::InvalidValue, CardsManager::UnknownAttribute => e
    puts e.message
  end

  private

  attr_reader :no_cache, :argv

  def initialize(argv)
    @no_cache = argv.delete('--no-cache')
    @argv = argv
  end

  def requested_cards
    CardsManager.new(query, cards_source).requested_cards
  end

  def query
    Query.new(argv).build
  end

  def cards_source
    Cards.get(no_cache)
  end
end
